package org.test.domain;

import static org.axonframework.commandhandling.model.AggregateLifecycle.apply;

import org.axonframework.commandhandling.CommandHandler;
import org.axonframework.commandhandling.model.AggregateIdentifier;
import org.axonframework.eventsourcing.EventSourcingHandler;
import org.axonframework.spring.stereotype.Aggregate;

@Aggregate
public class Test {

    @AggregateIdentifier
    String id;

    @CommandHandler
    public Test(CreateTestCommand command) {
        apply(new TestCreatedEvent(command.getId()));
    }

    @EventSourcingHandler
    public void on(TestCreatedEvent event) {
        id = event.getId();
    }

}
