package org.test.domain;

import static org.axonframework.commandhandling.model.AggregateLifecycle.apply;

import org.axonframework.commandhandling.CommandHandler;
import org.axonframework.commandhandling.model.AggregateIdentifier;
import org.axonframework.eventsourcing.EventSourcingHandler;
import org.axonframework.spring.stereotype.Aggregate;

import lombok.extern.slf4j.Slf4j;

@Slf4j
@Aggregate
public class Test2 {

    @AggregateIdentifier
    String id;

    @CommandHandler
    public Test2(CreateTest2Command command) {
        log.info("I was called");
        apply(new Test2CreatedEvent(command.getId()));
    }

    @EventSourcingHandler
    public void on(Test2CreatedEvent event) {
        id = event.getId();
    }

}
