package org.test.ui;

import org.axonframework.commandhandling.gateway.CommandGateway;
import org.axonframework.common.IdentifierFactory;
import org.test.domain.CreateTestCommand;

import com.vaadin.annotations.Theme;
import com.vaadin.annotations.Title;
import com.vaadin.server.VaadinRequest;
import com.vaadin.spring.annotation.SpringUI;
import com.vaadin.ui.Button;
import com.vaadin.ui.Button.ClickEvent;
import com.vaadin.ui.UI;
import com.vaadin.ui.VerticalLayout;

import lombok.extern.slf4j.Slf4j;

@Slf4j
@Theme("valo")
@Title("TestUI")
@SpringUI(path = "")
public class TestUI extends UI {

    private static final long serialVersionUID = 1L;

    private transient CommandGateway gateway;

    public TestUI(CommandGateway gateway) {
        super();
        this.gateway = gateway;
    }

    @Override
    protected void init(VaadinRequest vaadinRequest) {
        VerticalLayout layout = new VerticalLayout();
        layout.setSpacing(true);
        layout.setMargin(true);
        setContent(layout);
        Button prpButton = new Button("Test");
        layout.addComponent(prpButton);
        prpButton.addClickListener(this::doTest);

    }

    public void doTest(ClickEvent event) {
        log.info("creating test");
        gateway.send(new CreateTestCommand(IdentifierFactory.getInstance().generateIdentifier()));
    }

}
